C   Subroutine to Calculate Matrix of max D differences between ternary mixtures and Default sample
      subroutine sub_dmatx(defname,sname,nsp)
	PARAMETER(NPS=16500,NG=1000,EPS=0.1,ngd=16384,ns=20)
	DIMENSION a(ns),amin(ns),xdev(nps),ydev(nps),yaux(nps) 
      common /arrays/ DATA1(0:ns,nps),xmat(0:ng,0:ng),pxmatin(0:ng,0:ng)
     *,pxmatid(0:ng,0:ng),eroid(0:ng,0:ng),eroin(0:ng,0:ng)
      Common /var/ MG,nsz(ns),sigma,mtype
c	EXTERNAL FUNC
      character*9,ans*1,defname*10,sname(nsp)*10
      character*9  tab1,snamatx*10

	kn=name(defname) 
      open(unit=10,file=defname(1:kn)//'.txt',status='old')

	dng = 100./NG

          n1=1 
10        read(10,*,ERR=12,END=12)xdev(n1),gd,data1(0,n1)
          data1(0,n1)=data1(0,n1)/100.
	    n1=n1+1 
          goto 10
12        data1(0,n1)=1.
          close(10)

      do k=1,nsp
        sdata1 = 0.d0
	  sdata2 = 0.d0
	  kn=name(sname(k)) 
        open(unit=12,file=sname(k)(1:kn)//'.txt',status='old')
          n2=1
14          read(12,*,ERR=16,END=16)xd,gd,data1(k,n2)
          data1(k,n2) = data1(k,n2)/100.
	    n2=n2+1
          goto 14
16        data1(k,n2)=1.
	    close(12)
	enddo

18    D = 1.

	snamatx =sname(1)(1:2)//'_'//sname(2)(1:2)//'_'//sname(3)(1:2)

      kn=name(snamatx)
	open(unit=22,file=snamatx(1:kn)//'_param.dat',access='APPEND')
	open(unit=20,file=snamatx(1:kn)//'_opt_dist.dat')
	open(unit=21,file=snamatx(1:kn)//'_matx.dat')

C   minimization of D	
c     a() parameters vary only for three sum a(j) =1  
      do jl=0,NG
         do jm=0,NG
	     xmat(jl,jm)=-1
	   enddo
	enddo

      do  jl=0,NG
	   a(1) = jl*dng
	  do  jm=0,NG-jl
	    a(2)= jm*dng
          a(3) = 100. - a(1) - a(2)
          do  jn = 1,k
             do  j = 1,n2
               ydev(j)= ydev(j) + a(jn)*data1(jn,j)/100.
	       enddo
	    enddo
	    DN = 0.
          do j = 1,n2
	       Dcum = abs(data1(0,j)-ydev(j))	
	       if(Dcum.gt.DN)then
		     DN=Dcum
	         agemax = xdev(j)
	       endif
          enddo
	    xmat(jl,jm)=DN
          if(DN.lt.D)then
	       D=DN
	       do js=1,k
	         amin(js)=a(js)
	       enddo
	       do j=1,n2
	          yaux(j)=ydev(j)
	       enddo
	    endif
	       do j=1,n2
	          ydev(j)=0.
	       enddo
	   enddo
	enddo
	write(22,*)
	write(22,*)'D-MATRIX SUBROUTINE'
	write(22,*)   
	Write(22,*)defname(1:kn),'N= ',MG,'        (Main Trunk Sample)'
	do k=1,3
		write(22,*)sname(k)(1:2),' N=',nsz(k)
      enddo
	write(22,*)'D    %S1     %S2     %S3       '
      write(22,130)D,amin(1),amin(2),amin(3)
	write(20,100)(xdev(j),yaux(j)*100.,j=1,n2-1)
	do jl=0,NG
	   write(21,120)(xmat(jl,jm),jm=0,NG)
	enddo
	close(22)
      RETURN
100   format(2g20.8)
120   format(1001f10.6)
130   format(5f10.4,I4,4f10.4)
      END

