C     Subroutine to look for border points
      Subroutine border(D,xmat)
	PARAMETER(NG=1000,NN=100)
	dimension xmat(0:ng,0:ng)
	common /bord/ Al(NN),BL(NN),CL(NN),AB(3),ka(3)
C     jl=0 the Al(kl), jm=0 then Bl(km), jn=0 then Cl(kn)
C     AB(1)=A100,AB(2)=A010,AB(3)=A001
C     KA(1)=kl, KA(2),Km, KA(3)=KN

C   EXTREMES CALCULATIONS
	AB(1) =  D - xmat(NG,0)
      AB(2) =  D - xmat(0,NG)
	AB(3) =  D - xmat(0,0)

c	print *,AB(1),AB(2),AB(3)

C     FIRST RASTER JL=0
         jl = 0
	   kl = 1
	   do jm=0,NG-jl-1
	    XD = (D-xmat(jl,jm))*(D-xmat(jl,jm+1))
	   if(XD.le.0.)then
	      xjm=jm + (D-xmat(jl,jm))/(xmat(jl,jm+1)-xmat(jl,jm))
	      Al(kl) = xjm
	      kl=kl+1
	   endif   
	   enddo
	   kl = kl - 1  
	   
C     SECOND RASTER JM=0
         jm = 0
	   km = 1
	   do jl=0,NG-1
	     XD = (D-xmat(jl,jm))*(D-xmat(jl+1,jm))
	   if(XD.le.0.)then
	       xjl=jl + (D-xmat(jl,jm))/(xmat(jl+1,jm)-xmat(jl,jm)) 
             BL(km) = xjl
	       km = km + 1
	   endif
	   enddo
	   km = km -1

C     THIRD RASTER JN=0  JL + JM = NG
      kn = 1
      do jl=0,NG-1
	   jm = NG - jl
	     XD = (D-xmat(jl,jm))*(D-xmat(jl+1,jm-1))
	   if(XD.le.0.)then
           CL(kn)= jl + (D-xmat(jl,jm))/(xmat(jl+1,jm-1)-xmat(jl,jm))	     
	     kn = kn + 1
	   endif
      enddo
         kn = kn - 1

         ka(1)=kl
	   ka(2)=km
	   ka(3)=kn


	return
	end                              