      SUBROUTINE origkstwo(data1,n1,data2,n2,d,prob)
      INTEGER n1,n2
      REAL d,prob,data1(n1),data2(n2)
CU    USES probks,sort
      INTEGER j1,j2
      REAL d1,d2,dt,en1,en2,en,fn1,fn2,probks
      call sort(n1,data1)
      call sort(n2,data2)
      en1=n1
      en2=n2
      j1=1
      j2=1
      fn1=0.
      fn2=0.
      d=0.
1     if(j1.le.n1.and.j2.le.n2)then
        d1=data1(j1)
        d2=data2(j2)
        if(d1.le.d2)then
          fn1=j1/en1
          j1=j1+1
        endif
        if(d2.le.d1)then
          fn2=j2/en2
          j2=j2+1
        endif
        dt=abs(fn2-fn1)
        if(dt.gt.d)d=dt
      goto 1
      endif
      en=sqrt(en1*en2/(en1+en2))
      prob=probks((en+0.12+0.11/en)*d)
      return
      END

      SUBROUTINE kstwo(data1,n1,data2,n2,d,prob)
      INTEGER n1,n2
      REAL d,prob,data1(n1),data2(n2)
CU    USES probks,sort
      INTEGER j1,j2
      REAL d1,d2,dt,en1,en2,en,fn1,fn2,probks
      call sort(n1,data1)
      call sort(n2,data2)
      en1=n1
      en2=n2
      j1=1
      j2=1
      fn1=0.
      fn2=0.
      d=0.
1     if(j1.le.n1.and.j2.le.n2)then
        d1=data1(j1)
        d2=data2(j2)
	  nflag = -1
        if(d1.le.d2)then
          fn1=j1/en1
          if(J1.lt.EN1.or.EN1.GE.EN2.or.d1.ne.d2)then
		   j1=j1+1
	       if(j1.gt.n1)goto 2
	       if(d1.eq.data1(j1).and.j1.lt.EN1)nflag=0
	    endif
        endif
        if(d2.le.d1)then
          fn2=j2/en2
          if(J2.lt.EN2.or.EN2.GE.EN1.or.d1.ne.d2)then
		   j2=j2+1
	       if(j2.gt.n2)goto 2
	       if(d2.eq.data2(j2).and.j2.lt.EN2)nflag=0
	    endif
        endif
        dt=abs(fn2-fn1)
        if(dt.gt.d.and.nflag.lt.0)then
	       d=dt
	       jm1 = j1
	       jm2 = j2
		   aged= max(data1(jm1),data2(jm2))
	  endif
        goto 1
      endif
c	print *,'Sort positions for Dmin (JM1,JM2):',jm1,jm2
c	print *,'Age(Dmin) = ',aged
2      en=sqrt(en1*en2/(en1+en2))
      prob=probks((en+0.12+0.11/en)*d)

      return
      END      

      SUBROUTINE kstwonpg(data1,n1,data2,n2,d,prob,NPG,aged)
      INTEGER n1,n2
      REAL d,prob,data1(n1),data2(n2)
CU    USES probks,sort
      INTEGER j1,j2
      REAL d1,d2,dt,en1,en2,en,fn1,fn2,probks
      call sort(n1,data1)
      call sort(n2,data2)
      en1=n1
      en2=n2
      j1=1
      j2=1
      fn1=0.
      fn2=0.
      d=0.
1     if(j1.le.n1.and.j2.le.n2)then
        d1=data1(j1)
        d2=data2(j2)
	  nflag = -1
        if(d1.le.d2)then
          fn1=j1/en1
          if(J1.lt.EN1.or.EN1.GE.EN2.or.d1.ne.d2)then
		   j1=j1+1
	       if(j1.gt.n1)goto 2
	       if(d1.eq.data1(j1).and.j1.lt.EN1)nflag=0
	    endif
        endif
        if(d2.le.d1)then
          fn2=j2/en2
          if(J2.le.EN2.or.EN2.GE.EN1.or.d1.ne.d2)then
		   j2=j2+1
	       if(j2.gt.n2)goto 2
	       if(d2.eq.data2(j2).and.j2.lt.EN2)nflag=0
	    endif
        endif
        dt=abs(fn2-fn1)
        if(dt.gt.d.and.nflag.lt.0)then
	       d=dt
	       jm1 = j1
	       jm2 = j2
	       aged= max(data1(jm1),data2(jm2))
	  endif
        goto 1
      endif
2	print *,'Sort positions for Dmin (JM1,JM2):',jm1,jm2
	print *,'Age(Dmin) = ',aged
      en=sqrt(en1/npg*en2/(en1+en2))
      prob=probks((en+0.12+0.11/en)*d)

      return
      END      	
		
      SUBROUTINE KSTWOMOD(DATA1,N1,DATA2,N2,D,PROB)
      DIMENSION DATA1(N1),DATA2(N2)
      CALL SORT(N1,DATA1)
      CALL SORT(N2,DATA2)
      EN1=N1
      EN2=N2
      J1=1
      J2=1
      FO1=0.
      FO2=0.
      D=0.
1     IF(J1.LE.N1.AND.J2.LE.N2)THEN
        
	  IF(DATA1(J1).LT.DATA2(J2))THEN
          FN1=J1/EN1
          DT=AMAX1(ABS(FN1-FO2),ABS(FO1-FO2))
          IF(DT.GT.D.and.J1.EQ.EN1)then
		   D=DT
	       ND=1
	       JMAX = J1
	       DATAMAX = DATA1(J1)
		ELSEIF(DT.GT.D.and.DATA1(J1).NE.DATA1(J1+1))then
		   D=DT
	       ND=1
	       JMAX = J1
	       DATAMAX = DATA1(J1)
	    ENDIF
          FO1=FN1
          J1=J1+1
	  ELSEIF(DATA1(J1).EQ.DATA2(J2))THEN
	     FN1=J1/EN1
           FN2=J2/EN2
	     if(J1.lt.EN1.or.EN1.GT.EN2)J1=J1+1
           if(J2.lt.EN2.or.EN2.GT.EN1)J2=J2+1
           FO1=FN1
           FO2=FN2
        ELSE
          FN2=J2/EN2
          DT=AMAX1(ABS(FN2-FO1),ABS(FO2-FO1))
          IF(DT.GT.D.and.J2.EQ.EN2)then
		   D=DT
	       ND=2
	       JMAX = J2
	       DATAMAX = DATA2(J2)
		ELSEIF(DT.GT.D.and.DATA2(J2+1).NE.DATA2(J2))THEN
		   D=DT
	       ND=2
	       JMAX = J2
	       DATAMAX = DATA2(J2)
	    ENDIF
          FO2=FN2
          J2=J2+1
        ENDIF
      GO TO 1
      ENDIF
	PRINT *,ND,JMAX,DATAMAX
      en=sqrt(en1*en2/(en1+en2))
      prob=probks((en+0.12+0.11/en)*d)
c      PROB=PROBKS(SQRT(EN1*EN2/(EN1+EN2))*D)
      RETURN
      END


      FUNCTION PROBKS(ALAM)
      PARAMETER (EPS1=0.001, EPS2=1.E-8)
      A2=-2.*ALAM**2
      FAC=2.
      PROBKS=0.
      TERMBF=0.
      DO 11 J=1,100
        TERM=FAC*EXP(A2*J**2)
        PROBKS=PROBKS+TERM
        IF(ABS(TERM).LT.EPS1*TERMBF.OR.ABS(TERM).LE.EPS2*PROBKS)RETURN
        FAC=-FAC
        TERMBF=ABS(TERM)
11    CONTINUE
      PROBKS=1.
      RETURN
      END


      SUBROUTINE SORT(N,RA)
      DIMENSION RA(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END
