C MAIN PROGRAM TO CALCULATE CPDF, GKS STATISTIC, D AND PROB MATRIX, AND TERNARY CONTOURS

	PARAMETER(NPS=16500,nts=4000,nsamp=100,ng=1000,ns=20)

      dimension daux(nts),saux(nts)
      common /arrays/ DATA1(0:ns,nps),xmat(0:ng,0:ng),pxmatin(0:ng,0:ng)
     *,pxmatid(0:ng,0:ng),eroid(0:ng,0:ng),eroin(0:ng,0:ng)
      Common /var/ MG,nsz(ns),sigma,mtype
	

      character*9  tab1,yes*1,snamatx*10,yaux*1
c	tab1=char(09)

      character*9,ans*1,defname*10,sname(20)*10


	Print *,'SELECT THE ROUTINE(S) YOU WANT TO RUN'
	Print *
	Print *,'(a) - RUN ALL THE ROUTINES AT ONCE'
	Print *
	Print *,'(1) - CALCULATE PDF, CPDF CURVES AND STATISTIC AND 
     *CORRELATION VALUES (1)'
	Print *
	Print *,'(2) - CALCULATE D MATRIX FOR TERNARY PLOTS'
	Print *
	Print *,'(3) - CALCULATE THE PROBABILITY MATRIX'
	Print *
	Print *,'(4) - CALCULATE THE EROSION MATRIX'
	Print *
	Print *,'(5) - CALCULATE TERNARY CONTOURS (PROB OR EROSION)'
	Print *
      Print *, 'ENTER SELECTION?'
      read  *,ans
c	Print *,'DO YOU WANT TO RUN ANY OTHER PROCESS WITH THESE SAMPLES? (yes/no)'

     	print *,'Enter name of Main sample distribution'
	read *,defname
      kn=name(defname)
	if(kn.lt.2.or.kn.gt.10)goto 90
      nsp=0
20	print *,'ENTER NAME OF CATCHMENT SAMPLE (STOP to end reading)'
	read *,sname(nsp+1)
      kn=name(sname(nsp+1))
	if(kn.lt.2.or.kn.gt.10)goto 90
	nsp=nsp+1
	if(sname(nsp)(1:4).eq.'stop'.or.sname(nsp)(1:4).eq.'STOP'.or.nsp.
     *gt.20)then
	  nsp = nsp - 1 
	else
	  goto 20  
	endif
C READ SAMPLES
        sigma = 0
        call readsample(defname,MG,daux,saux,avgsig)
	  sigma = sigma + avgsig
      do i=1,nsp
        call readsample(sname(i),nsz(i),daux,saux,avgsig)
	if(nsp.le.3)sigma = sigma + avgsig
	enddo
	  sigma = sigma/4.*100.
  	  snamatx =sname(1)(1:2)//'_'//sname(2)(1:2)//'_'//sname(3)(1:2)
      if(ans.eq.'3'.or.ans.eq.'4'.or.ans.eq.'5')then
        Print *, 'ENTER TYPE OF MODEL YOU WANT TO CALCULATE:'
	  Print *
	  Print *, '(1) - INDEPENDENT'
	  Print *
	  Print *, '(2) - IDENTICAL'
	  Print *
	  Print *, '(3) - BOTH'
        Read *,mtype
      elseif(ans.eq.'a')then
	  mtype= 3
	  mans = 3
	endif
      if(ans.eq.'5')then
	  Print *
	  Print *,'(1) - CALCULATE CONTOURS OF PROB MATRIX'
	  Print *
	  Print *,'(2) - CALCULATE CONTOURS OF EROSION MATRIX'
	  Print *
	  Print *,'(3) - CALCULATE BOTH CONTOURS (PROB & EROSION)'
	  read *,mans
	  maux = -1
	endif
	if(ans.eq.'a'.or.ans.eq.'1')then
	  kn=name(snamatx)
	  open(unit=9,file=snamatx(1:kn)//'_param.dat',status='REPLACE')
	endif
C   CALL GENKS TO CALCULATES CPDF AND GKS STATISTIC

      if(ans.eq.'1'.or.ans.eq.'a')then
	   call sub_genks(defname,sname,nsp)
	write(9,*) 'Total Average % sigma= ',sigma
	close(9)
	   if(ans.eq.'1')goto  30
      endif
	Print *,'GENKS DONE' 

C   CALL DMATX TO CALCULATE THE D TERNARY MATRIX
2     if(ans.eq.'2'.or.ans.eq.'a')then
       if(nsp.gt.3)then
        Print *, 'THIS PROGRAM WILL CALCULATE THE TERNARY D-MATRIX FOR 
     *   THE 1ST THREE CATCHMENT SAMPLES'
	 elseif(nsp.lt.3)then
	  Print *, 'SORRY, NO ENOUGH CATCHMENT SAMPLES TO CALCULATE 
     *TERNARY PLOTS'
	  goto 30
	 endif
	  nsp = 3
        call sub_dmatx(defname,sname,nsp)
	if(ans.eq.'2')goto 30
      endif
	Print *,'DMATX DONE' 

C    CALL PROB_DCRIT_MTX TO CALCULATE THE PROBABILITY MATRIX
      if(ans.eq.'3')then
	  maux1=0
C      READ D_matrix	  
        kn=name(snamatx)
	  open(unit=10,ERR=80,file=snamatx(1:kn)//'_matx.dat',status='old')
	  do jl=0,NG
	   read(10,122)(xmat(jl,jm),jm=0,NG)
	  enddo
        close(10)
122     format(1x,1001f10.6)
      endif
      if(ans.eq.'3'.or.ans.eq.'a')then
	  if(mtype.eq.3)then
	    maux1=mtype
	    mtype=1
	  endif
5        call sub_probmtx(snamatx,nsp)
	  if(maux1.eq.3)then
	   mtype=2
	   maux1=1
	   goto 5
	  endif
	  if(maux1.eq.1)mtype=3
	endif
	if(ans.eq.'3')goto 30
	Print *,'PROB_DCRIT_MTX DONE' 
C   CALL EROSION TO CALCULATE THE EROSION MATRIX FROM THE PROB MATRIX (OPTIONAL)
4     if(ans.eq.'4')then
C       READ P_matrix	  
        kn=name(snamatx)
       if(mtype.eq.1.or.mtype.eq.3)then
	    open(unit=10,ERR=82,file=snamatx(1:kn)//'_pmatxin.dat',
     *    status='old')
	    do jl=0,NG
	      read(10,123)(pxmatin(jl,jm),jm=0,NG)
	    enddo
	  elseif(mtype.eq.2)then
	    open(unit=10,ERR=84,file=snamatx(1:kn)//'_pmatxid.dat',
     *    status='old')
	    do jl=0,NG
            read(10,123)(pxmatid(jl,jm),jm=0,NG)
	    enddo
        endif
        close(10)
123     format(1x,1001f10.6)
      endif
      if(ans.eq.'4'.or.ans.eq.'a')then
        call sub_erosion_mtx(snamatx,nsp)
	  if(mtype.eq.3)then
	    maux=mtype
	    mtype=2
	    goto  4
	  endif
	  if(ans.eq.'4')goto 30
	  mtype=maux
      endif
	Print *,'EROSION DONE' 
C   CALL CONTOUR TO CALCULATE THE TERNARY CONTOURS OF THE PROB MATRIX
      maux = -1
	msaux = -1
6	if(ans.eq.'5')then
C       READ P_matrix	or Erosion matrix  
        kn=name(snamatx)
        if((mans.eq.1.or.mans.eq.3).and.(mtype.eq.1.or.mtype.eq.3))then
	    open(unit=10,ERR=82,file=snamatx(1:kn)//'_pmatxin.dat',
     *    status='old')
		  do jl=0,NG
	         read(10,123)(pxmatin(jl,jm),jm=0,NG)
	      enddo
	  elseif((mans.eq.1.or.mans.eq.3).and.mtype.eq.2)then
	    open(unit=10,ERR=84,file=snamatx(1:kn)//'_pmatxid.dat',
     *    status='old')
		  do jl=0,NG
	         read(10,123)(pxmatid(jl,jm),jm=0,NG)
	      enddo
	  elseif(mans.eq.2.and.(mtype.eq.1.or.mtype.eq.3))then
		open(unit=10,ERR=86,file=snamatx(1:kn)//'_erin.dat',
     *    status='old')
		  do jl=0,NG
	        read(10,123)(eroin(jl,jm),jm=0,NG)
	      enddo
	  elseif(mans.eq.2.and.mtype.eq.2)then
	    open(unit=10,ERR=88,file=snamatx(1:kn)//'_erid.dat',
     *    status='old')
		  do jl=0,NG
	        read(10,123)(eroid(jl,jm),jm=0,NG)
	      enddo
        endif
        close(10)
      endif 
	if(ans.eq.'5'.or.ans.eq.'a')then
	  if(mans.eq.3)then
	    msaux=mans
	    mans=1
	  endif
	  if(mtype.eq.3)then
	     maux=mtype
	     mtype=1
	  endif
	  if(maux.eq.3.and.msaux.eq.3)then
	     call sub_contour(snamatx,nsp,mans)
           if(mtype-mans.eq.1)then
	       mtype = maux
	       mans = msaux
	       goto 7
		 endif
	     if(mtype.eq.2)mans=1
	     if(mans.eq.2)mtype=2
	     if(mans.eq.1.and.mtype.eq.1)mans=2
		 goto 6
	  endif
7	  if(maux.eq.3.and.msaux.ne.3)then
           call sub_contour(snamatx,nsp,mans)
	     mtype = mtype + 1
	     if(mtype.lt.3)goto 6
	  endif
	  if(maux.ne.3.and.msaux.eq.3)then
           call sub_contour(snamatx,nsp,mans)
	     mans = mans + 1
	     if(mans.lt.3)goto 6
        endif
	  if(maux.ne.3.and.msaux.ne.3)then
           call sub_contour(snamatx,nsp,mans)
        endif

	  if(ans.eq.'5')goto 30
	  mtype=maux
      endif	       
	Print *,'CONTOUR DONE' 

30    stop
80    Print *,'D Matrix file ',snamatx(1:kn),'_matx.dat NOT FOUND'
      STOP 'YOU MUST CALCULATE D MATRIX FIRST, RUN (2) AND TRY AGAIN'

82    Print *,'P Matrix file ',snamatx(1:kn),'_pmatxin.dat NOT FOUND'
	STOP 'YOU MUST CALCULATE PROBABILITY MATRIX FIRST, RUN (3) AND 
     *TRY AGAIN'

84    Print *,'P Matrix file ',snamatx(1:kn),'_pmatxid.dat NOT FOUND'
	STOP 'YOU MUST CALCULATE PROBABILITY MATRIX FIRST, RUN (3) AND 
     *TRY AGAIN'

86    Print *,'P Matrix file ',snamatx(1:kn),'_erin.dat NOT FOUND'
	STOP 'YOU MUST CALCULATE PROBABILITY MATRIX FIRST, RUN (4) AND 
     *TRY AGAIN'

88    Print *,'Erosion Matrix file ',snamatx(1:kn),'_erid.dat NOT FOUND'
	STOP 'YOU MUST CALCULATE PROBABILITY MATRIX FIRST, RUN (4) AND 
     *TRY AGAIN'

90    Print *,'Sample FILENAME LENGTH must be between 2 & 10'
      STOP 'PLEASE, RENAME YOUR INPUT FILES AND TRY AGAIN'
      end