C  PROGRAM TO CALCULATE PROB AND DCRIT MATRIX FROM (d-MATRIX)      
      subroutine sub_erosion_mtx(snamatx,nsp)
	PARAMETER(NPS=16500,NG=1000,EPS=0.1,ngd=16384,ns=20,xacc=1.0e-4)
      common /arrays/ DATA1(0:ns,nps),xmat(0:ng,0:ng),pxmatin(0:ng,0:ng)
     *,pxmatid(0:ng,0:ng),eroid(0:ng,0:ng),eroin(0:ng,0:ng)
      Common /var/ MG,nsz(ns),sigma,mtype
      COMMON WT(ns),M,XM
	dimension axmat(0:ng,0:ng)
	doubleprecision awt(ns),owt(ns),kwt(ns),dng
	External Probs,Probsid,dcprobs,dcprobsid
      character*9  tab1,snamatx*10
      XM=MG
	M=nsp
	dng=1.d0/real(NG)
	open(unit=10,file='predicted.in',ERR=80,status='old')
	read(10,*)(wt(jm),jm=1,3)
	close(10)
	kn=name(snamatx)
1	if(mtype.eq.1.or.mtype.eq.3)then
	  open(unit=27,file=snamatx(1:kn)//'_erin.dat')
	elseif(mtype.eq.2)then
	  open(unit=27,file=snamatx(1:kn)//'_erid.dat')
	endif
      testing = 0.
      do  jl=0,NG
	   do jm=0,NG
		   axmat(jl,jm)=-1.
	   enddo	   
      enddo
      do  jl=0,NG
	  awt(1) = real(jl)*dng
        do  jm=0,NG-jl
	    awt(2)= real(jm)*dng	    
          awt(3) = 1. - awt(1) - awt(2)
	    sum = 0.
          do j1=1,3
	       owt(j1) = awt(j1)*wt(j1)
	       sum = sum + owt(j1)
	    enddo
	    sumtest = 0.
          do j1=1,3
	       kwt(j1)=aint(owt(j1)/sum/dng)
	    enddo
	    if(mtype.eq.1.or.mtype.eq.3)then
	      eroin(jl,jm)=pxmatin(kwt(1),kwt(2))
	    elseif(mtype.eq.2)then
	      eroid(jl,jm)=pxmatid(kwt(1),kwt(2))
	    endif
        enddo
      enddo
      do jl=0,NG   
	  if(mtype.eq.1.or.mtype.eq.3)then
          write(27,120)(eroin(jl,jm),jm=0,NG)
	  elseif(mtype.eq.2)then
          write(27,120)(eroid(jl,jm),jm=0,NG)
        endif
	enddo
      close(27)
      return
80    print *,'Erosion input file: predicted.in ;NOT FOUND' 
      print *,'Erosion matrix will be calculate with uniform'
	print *,'relative contributions (1/3,1/3,1/3)'
      data wt(1),wt(2),wt(3)/0.3333333,0.3333333,0.3333334/
      goto 1
120   format(1001f10.6)
122   format(1x,1001f10.6)
      end



C ROUNDED ROUTINE (MODIFIED BY USING DOUBLE PRECISION AUX VARIABLE)
c	    awt1 = (wt(1)*1000.-ANINT(wt(1)*1000.))/1000.
c         awt2 = (wt(2)*1000.-ANINT(wt(2)*1000.))/1000.
c	    awt3 = (wt(3)*1000.-ANINT(wt(3)*1000.))/1000.
c	    wt(1)= wt(1)-awt1
c          wt(2)= wt(2)-awt2
c          wt(3)= wt(3)-awt3